"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
// required until https://github.com/DefinitelyTyped/DefinitelyTyped/issues/28648
var btoa = require("btoa"); // tslint:disable-line:no-var-requires
var node_fetch_1 = require("node-fetch");
var APIVersion;
(function (APIVersion) {
    APIVersion[APIVersion["V1"] = 0] = "V1";
    APIVersion[APIVersion["V2"] = 1] = "V2";
})(APIVersion || (APIVersion = {}));
var Targetprocess = /** @class */ (function () {
    function Targetprocess(subdomain, username, password) {
        this.subdomain = subdomain;
        this.headers = {
            "Accept": "application/json",
            "Authorization": "Basic " + btoa(username + ":" + password),
            "Cache-Control": "no-cache",
            "Content-Type": "application/json"
        };
    }
    Targetprocess.prototype.getBug = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.requestJSON(APIVersion.V1, "Bugs/" + id, "GET")];
            });
        });
    };
    Targetprocess.prototype.getTask = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.requestJSON(APIVersion.V1, "Tasks/" + id, "GET")];
            });
        });
    };
    Targetprocess.prototype.getStory = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.requestJSON(APIVersion.V1, "Userstories/" + id, "GET")];
            });
        });
    };
    Targetprocess.prototype.setTaskState = function (id, stateName, processId) {
        return __awaiter(this, void 0, void 0, function () {
            var doneEntity, doneEntityId, body;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getTaskEntityState(stateName, processId)];
                    case 1:
                        doneEntity = _a.sent();
                        if (!doneEntity || !doneEntity.Items || !Array.isArray(doneEntity.Items) || doneEntity.Items.length > 1) {
                            return [2 /*return*/];
                        }
                        doneEntityId = doneEntity.Items[0].Id;
                        body = {
                            EntityState: { Id: doneEntityId }
                        };
                        return [2 /*return*/, this.requestJSON(APIVersion.V1, "Tasks/" + id, "POST", body)];
                }
            });
        });
    };
    Targetprocess.prototype.addTime = function (id, spent, remain, date, description) {
        return __awaiter(this, void 0, void 0, function () {
            var body;
            return __generator(this, function (_a) {
                body = {
                    Spent: spent,
                    Remain: remain,
                    Date: date,
                    Description: description,
                    Assignable: {
                        Id: id
                    }
                };
                return [2 /*return*/, this.requestJSON(APIVersion.V1, "Times/", "POST", body)];
            });
        });
    };
    Targetprocess.prototype.getCustomValueForProject = function (projectId, customValueKey) {
        return __awaiter(this, void 0, void 0, function () {
            var url, response, item, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "Project/" + projectId + "?select={val:CustomValues[\"" + customValueKey + "\"]}";
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.requestJSON(APIVersion.V2, url, "GET")];
                    case 2:
                        response = _a.sent();
                        item = response.items[0];
                        if (item.val === undefined) {
                            return [2 /*return*/, null];
                        }
                        return [2 /*return*/, item.val];
                    case 3:
                        e_1 = _a.sent();
                        throw e_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Targetprocess.prototype.getTaskEntityState = function (name, processId) {
        return __awaiter(this, void 0, void 0, function () {
            var response, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.requestJSON(APIVersion.V1, "EntityStates?where=(Name eq \"" + name + "\")and(Process.Id eq " + processId + ")and(EntityType.Name eq \"Task\")", "GET")];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 2:
                        e_2 = _a.sent();
                        console.error(e_2);
                        return [2 /*return*/];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Targetprocess.prototype.requestJSON = function (version, endpoint, method, body) {
        return __awaiter(this, void 0, void 0, function () {
            var url, fullUrl, data, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.getUrlForAPIVersion(version);
                        fullUrl = url + "/" + endpoint;
                        data = { method: method, headers: this.headers };
                        if (body) {
                            data.body = JSON.stringify(body);
                        }
                        return [4 /*yield*/, node_fetch_1["default"](fullUrl, data)];
                    case 1:
                        res = _a.sent();
                        if (!res.ok) {
                            throw {
                                statusCode: res.status,
                                message: res.statusText
                            };
                        }
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    Targetprocess.prototype.getUrlForAPIVersion = function (version) {
        if (version === APIVersion.V1) {
            return "https://" + this.subdomain + ".tpondemand.com/api/v1";
        }
        return "https://" + this.subdomain + ".tpondemand.com/api/v2";
    };
    return Targetprocess;
}());
exports.Targetprocess = Targetprocess;
